Rounded Donut in JavaScript

Using ApexCharts with JavaScript

This Rounded Donut example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var options = {
  series: [44, 25, 18, 13],
  chart: {
    type: 'donut',
    width: 420,
  },
  labels: [
    'Marguerite Tillman',
    'Gabriel Barton',
    'Kathleen Abernathy',
    'Devon Reyes',
  ],
  colors: ['#0EA5E9', '#14B8A6', '#F59E0B', '#F43F5E'],
  plotOptions: {
    pie: {
      // Round the corners of every slice (px)
      borderRadius: 12,
      // Leave a gap between adjacent slices (px)
      spacing: 5,
      donut: {
        size: '68%',
        labels: {
          show: true,
          total: {
            show: true,
            label: 'Total Orders',
          },
        },
      },
    },
  },
  stroke: {
    width: 0,
  },
  dataLabels: {
    enabled: false,
  },
  legend: {
    position: 'bottom',
  },
  title: {
    text: 'Orders by sales team',
    align: 'left',
  },
  responsive: [
    {
      breakpoint: 480,
      options: {
        chart: {
          width: 320,
        },
      },
    },
  ],
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Rounded Donut in Angular

Using ApexCharts with Angular

This Rounded Donut example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [44, 25, 18, 13],
          chart: {
            type: 'donut',
            width: 420,
          },
          labels: [
            'Marguerite Tillman',
            'Gabriel Barton',
            'Kathleen Abernathy',
            'Devon Reyes',
          ],
          colors: ['#0EA5E9', '#14B8A6', '#F59E0B', '#F43F5E'],
          plotOptions: {
            pie: {
              // Round the corners of every slice (px)
              borderRadius: 12,
              // Leave a gap between adjacent slices (px)
              spacing: 5,
              donut: {
                size: '68%',
                labels: {
                  show: true,
                  total: {
                    show: true,
                    label: 'Total Orders',
                  },
                },
              },
            },
          },
          stroke: {
            width: 0,
          },
          dataLabels: {
            enabled: false,
          },
          legend: {
            position: 'bottom',
          },
          title: {
            text: 'Orders by sales team',
            align: 'left',
          },
          responsive: [
            {
              breakpoint: 480,
              options: {
                chart: {
                  width: 320,
                },
              },
            },
          ],
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Rounded Donut in React

Using ApexCharts with React

This Rounded Donut example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [44, 25, 18, 13],
    options: {
      chart: {
        type: 'donut',
        width: 420,
      },
      labels: [
        'Marguerite Tillman',
        'Gabriel Barton',
        'Kathleen Abernathy',
        'Devon Reyes',
      ],
      colors: ['#0EA5E9', '#14B8A6', '#F59E0B', '#F43F5E'],
      plotOptions: {
        pie: {
          // Round the corners of every slice (px)
          borderRadius: 12,
          // Leave a gap between adjacent slices (px)
          spacing: 5,
          donut: {
            size: '68%',
            labels: {
              show: true,
              total: {
                show: true,
                label: 'Total Orders',
              },
            },
          },
        },
      },
      stroke: {
        width: 0,
      },
      dataLabels: {
        enabled: false,
      },
      legend: {
        position: 'bottom',
      },
      title: {
        text: 'Orders by sales team',
        align: 'left',
      },
      responsive: [
        {
          breakpoint: 480,
          options: {
            chart: {
              width: 320,
            },
          },
        },
      ],
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="donut"
          width={420}
        />
      </div>
    </div>
  )
}

export default ApexChart

Rounded Donut in Vue

Using ApexCharts with Vue

This Rounded Donut example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="donut"
        width="420"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [44, 25, 18, 13],
      chartOptions: {
        chart: {
          type: 'donut',
          width: 420,
        },
        labels: [
          'Marguerite Tillman',
          'Gabriel Barton',
          'Kathleen Abernathy',
          'Devon Reyes',
        ],
        colors: ['#0EA5E9', '#14B8A6', '#F59E0B', '#F43F5E'],
        plotOptions: {
          pie: {
            // Round the corners of every slice (px)
            borderRadius: 12,
            // Leave a gap between adjacent slices (px)
            spacing: 5,
            donut: {
              size: '68%',
              labels: {
                show: true,
                total: {
                  show: true,
                  label: 'Total Orders',
                },
              },
            },
          },
        },
        stroke: {
          width: 0,
        },
        dataLabels: {
          enabled: false,
        },
        legend: {
          position: 'bottom',
        },
        title: {
          text: 'Orders by sales team',
          align: 'left',
        },
        responsive: [
          {
            breakpoint: 480,
            options: {
              chart: {
                width: 320,
              },
            },
          },
        ],
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 420px;
  margin: 35px auto;
}
</style>